// Copyright 1999-2017. Parallels IP Holdings GmbH. All Rights Reserved.

PleskExt.Docker.LogsPopup = Class.create(Jsw.Popup, {
    _initConfiguration: function ($super, config) {
        config = Object.extend({
            "closeButtonEnabled": true
        }, config || {});
        $super(config);

        this._cls += ' popup-panel-lg';

        this.container = this._getConfigParam('container');
        this.urls = this._getConfigParam('urls', {});
        this.callback = this._getConfigParam('callback', function () {});

        this._config.title = this.lmsg("logsPopupTitle", {"name": this.container.title});

        this._buttons.push({
            "class": "action",
            "title": this.lmsg("close"),
            "handler": this.hide.bind(this)
        });

        this.logs = new PleskExt.Docker.Logs({
            dataUrl: this.urls.logs + '/id/' + encodeURIComponent(this.container.id)
        });
    },

    render: function($super) {
        $super();
        Jsw.render($(this._popupContentAreaId).down('form'), this.logs, 'top');
        if (this.container.running) {
            this.logs.start();
        }
    },

    hide: function ($super) {
        this.logs.stop();
        $super();
        this.callback();
    }
});
