// Copyright 1999-2020. Parallels IP Holdings GmbH. All Rights Reserved.

(function (cssPrefix) {

    PleskExt.Docker.Logs = Class.create(Jsw.Component, {
        _tag: 'pre',
        _prevScroll: 0,

        _initConfiguration: function ($super, config) {
            $super(config);

            this._cls = cssPrefix + 'console-output ' + cssPrefix + 'console-output-wide';
            this.dataUrl = this._getConfigParam('dataUrl');
            this.period = this._getConfigParam('period', 5);
        },

        render: function($super) {
            $super();

            Event.observe(this._componentElement, 'scroll', function() {
                this._prevScroll = this._componentElement.scrollTop;
            }.bind(this));

            this.reload();
        },

        view: function (logs) {
            return String(logs || '').escapeHTML() + (this.pe ? '<span class="' + cssPrefix + 'cursor ' + cssPrefix + 'animation-blink"></span>' : '');
        },

        reload: function () {
            new Ajax.Request(this.dataUrl, {
                method: 'get',
                onSuccess: function (transport) {
                    var logs = transport.responseText.evalJSON();
                    var scrollBottom = this._componentElement.scrollHeight + 2 -
                        (this._prevScroll + this._componentElement.getHeight());
                    this._componentElement.update(this.view(logs));
                    if (!scrollBottom) {
                        this._componentElement.scrollTop = this._componentElement.scrollHeight;
                    }
                }.bind(this)
            });
        },

        start: function () {
            this.pe = new PeriodicalExecuter(function () {
                this.reload();
            }.bind(this), this.period);
        },

        stop: function () {
            if (this.pe) {
                this.pe.stop();
                this.pe = null;
            }
        }
    });

})(PleskExt.Docker.PleskExtPrefix);
