// Copyright 1999-2017. Parallels IP Holdings GmbH. All Rights Reserved.

PleskExt.Docker.UploadAdapterAjax = Class.create({
    initialize: function (config) {
        this._handlerUrl = config.handlerUrl;
        this._startUploadHandler = config.startUploadHandler;
        this._finishUploadHandler = config.finishUploadHandler;
        this._progressUploadHandler = config.progressUploadHandler;
    },

    upload: function (file, params) {
        var formData = new FormData();
        formData.append(file.name, file);
        formData.append('forgery_protection_token', $('forgery_protection_token').content);
        if (params) {
            $H(params).each(function (pair) {
                if (!params.hasOwnProperty(pair.key)) {
                    return;
                }
                formData.append(pair.key, pair.value);
            });
        }

        this._request = new PleskExt.Docker.UploadAjaxRequest(
            this._handlerUrl,
            {
                method: 'post',
                postBody: formData,
                onCreate: this._startUploadHandler,
                onSuccess: this._finishUploadHandler,
                onException: this._finishUploadHandler,
                onProgress: this._progressUploadHandler
            }
        );
    },

    cancel: function () {
        this._request.abort();
    }
});
