<?php
// Copyright 1999-2017. Parallels IP Holdings GmbH. All Rights Reserved.

$messages = [
    'controllers' => [
        'index' => [
            'actions' => [
                'containerNotFound' => 'The container with ID %%id%% is not found.',
            ],
            'commit' => [
                'title' => 'Save as Image',
                'success' => 'An image was created based on the changes that you made to the container.',
                'error' => "%%error%%. This container cannot be saved as an image because the original container's image is not available.",
            ],
            'container' => [
                'title' => 'Container',
                'titleForObject' => 'Container %%name%%',
            ],
            'install' => [
                'titleForObject' => 'Run %%name%%',
                'redirectTitle' => 'Configure and Run',
                'imageNotFound' => 'The image with the name "%%name%%" is not found.',
                'success' => 'The container was started.'
            ],
            'list' => [
                'title' => 'Docker Catalog at %%node%%',
                'install' => 'Run',
                'installCached' => 'Run (local)',
                'imagesCached' => '%%count%% local images',
                'tagCached' => '%%tag%% (local)',
                'cachedImagesOf' => 'Local images of %%image%%',
                'cleanCache' => 'Clean All Images',
                'cleanCacheConfirmation' => 'Do you want to clean all <b>%%image%%</b> images?',
                'image' => 'Image',
                'details' => 'Details',
                'stop' => 'Stop',
                'start' => 'Start',
                'restart' => 'Restart',
                'logs' => 'Logs',
                'settings' => 'Settings',
                'remove' => 'Remove',
                'close' => 'Close',
                'running' => 'Running',
                'stopped' => 'Stopped',
                'memoryTitle' => 'Memory',
                'memoryLimitTitle' => 'Memory Limit',
                'usedOf' => 'used of',
                'containersTitle' => 'Your Containers',
                'imagesCatalogTitle' => 'Docker Image Catalog',
                'noAvailableCatalogItems' => 'No images are available in the catalog.',
                'noContainers' => 'No images are installed at the moment. You can install a Docker image from the catalog.',
                'removeConfirmation' => 'Do you want to remove this container?',
                'officialLabel' => 'Official',
                'starCount' => '%%count%% Stars',
                'localImageDescription' => 'Local image',
                'logsPopupTitle' => '%%name%% logs',
                'installTooltip' => 'Create and run a container based on this image.',
                'removeImageTooltip' => 'Remove this image',
                'removeImageConfirmation' => 'Do you want to remove the <b>%%image%%</b> image?',
                'removeImageAttention' => 'There are containers created from this image. They will be broken if you delete the image.',
                'loading' => 'Loading...',
                'filterImageName' => 'Name',
                'filterImageRepository' => 'Repository',
                'filterOptionImageRepositorAny' => 'Any',
                'filterOptionImageRepositorLocal' => 'Local',
                'filterOptionImageRepositorRemote' => 'Docker Hub',
                'buttonSearch' => 'Search',
                'buttonResetSearch' => 'Reset',
                'buttonUploadImage' => 'Upload Image',

                'uploadImage' => [
                    'title' => 'Uploading Image',
                    'description' => 'Uploading <b>%%filename%%</b>',
                    'sizeProgress' => '%%loaded%% of %%total%% uploaded...',
                    'progress' => '%%value%%% completed',
                    'unsupportedExtensions' => "Unsupported file extension. The following extensions are supported:<br /><b>%%extensions%%</b>",
                    'failed' => 'Failed',
                    'done' => 'Success',
                    'errorOccurred' => 'Some error occurred during the upload operation.',
                ]
            ],
            'overview' => [
                'title' => 'Overview',
                'startButton' => 'Start',
                'stopButton' => 'Stop',
                'restartButton' => 'Restart',
                'recreateButton' => 'Recreate',
                'recreateTitle' => 'Recreate %%name%%',
                'commitButton' => 'Save as Image',
                'exportButton' => 'Download Snapshot',
                'removeButton' => 'Remove',
                'removeConfirmation' => 'Do you want to remove this container?',
                'consoleLog' => 'Console Log',
                'resourcesSection' => 'Resources',
                'memory' => 'Memory',
                'memoryUsage' => '%%usage%% of %%limit%%',
                'cpu' => 'CPU',
                'containerId' => 'Container ID',
                'mounts' => 'Volume mapping',
                'mountOn' => '%%source%% on %%destination%%',
                'notMount' => 'not mounted %%destination%%',
                'ports' => 'Port mapping',
                'portTo' => '%%source%% to %%destination%%',
            ],
            'recreate' => [
                'redirectTitle' => 'Recreate',
                'success' => 'The container was successfully created.',
                'startError' => 'Failed to start the container: %%error%%'
            ],
            'start' => [
                'success' => 'The container was successfully started.',
            ],
            'restart' => [
                'success' => 'The container was successfully started.',
            ],
            'stop' => [
                'success' => 'The container was stopped.',
            ],
            'settings' => [
                'title' => 'Settings',
                'settingsSaved' => 'Container settings were saved.',
                'settingsError' => 'Error occurred on saving the settings: %%error%%.',
                'startError' => 'Failed to start the container: %%error%%',
            ],
            'remove' => [
                'success' => 'The container was removed.',
            ],
            'image-remove' => [
                'success' => 'The image %%name%% was removed.',
            ],
            'clean-image-cache' => [
                'success' => 'All images for %%name%% were removed.',
            ],
            'upload-image' => [
                'success' => 'The image %%name%% was successfully uploaded.',
            ],
        ],
        'configure' => [
            'list' => [
                'title' => 'Docker Settings',
                'buyLicenseLink' => 'here',
                'remoteDockerRestrictedByLicense' => 'Remote Docker node management is not available. Please install an additional license to enable remote Docker node management. Click %%link%% to purchase the license.',
                'faqLink' => 'this document',
                'repositoryLink' => 'repository',
                'localDockerNotSupported' => 'Local Docker nodes cannot be deployed in this environment. Only remote Docker nodes are available. Refer to %%faqLink%% for more information about the environment suitable for local Docker nodes. <br> You can use remote Docker nodes only if you have the paid version of the Docker extension. You can buy the extension %%link%%.<br>Note that Docker is not available for CentOS 8/RHEL 8 as long as %%centOSRepoLink%% does not contain the required packets. Red Hat offers an alternative named %%podmanLink%%, which you can install and use on your own.',
                'kbLink' => 'this KB article',
                'localDockerNotInstalled' => 'Local Docker node is missing. Refer to %%kbLink%% to resolve this issue. <br> The ability to work with remote nodes is available only in the paid version of the extension. You can buy the extension %%link%%.',
            ],
            'settings' => [
                'title' => 'Docker Server Settings',
                'settingsSaved' => 'Docker settings were saved.',
            ],
            'switch' => [
                'activated' => 'The Docker server %%server%% was marked as active.',
                'deactivated' => 'The Docker server %%server%% was marked as inactive.',
                'serverLocal' => 'localhost',
                'notSelected' => 'No item selected.',
            ],
            'remove' => [
                'removed' => 'The Docker servers were removed.',
            ],
        ],
        'proxyRule' => [
            'notAvailableWindows' => 'Docker Proxy Rule feature is not available for Windows',
            'actions' => [
                'siteIdRequired' => 'site_id parameter required',
            ],
            'list' => [
                'titleForObject' => 'Proxy Rules for %%name%%',
            ],
            'create' => [
                'title' => 'Add Rule',
                'created' => 'Proxy rule was created',
            ],
            'edit' => [
                'title' => 'Edit Rule',
                'saved' => 'Proxy rule was saved',
                'notFound' => 'Can not find rule with id = \'%%id%%\'',
            ],
            'remove' => [
                'removed' => 'Proxy rules were removed',
            ],
        ],
    ],

    'components' => [
        'form' => [
            'docker-settings' => [
                'active' => 'Set active',
                'activeDescription' => 'Setting the node as active will deactivate all other Docker nodes. Containers running on other nodes will continue working and will not be stopped.',
                'host' => 'Host',
                'port' => 'Port',
                'ssl' => 'Use SSL',
                'sslKey' => 'Private key',
                'sslKeyDescription' => 'Authentication private key, e.g. key.pem file',
                'sslCert' => 'Certificate',
                'sslCertDescription' => 'Authentication certificate, e.g. cert.pem file',
                'sslCa' => 'CA certificate',
                'sslCaDescription' => 'Server CA certificate, e.g. ca.pem file',
                'description' => 'Description',
            ],
            'container-settings' => [
                'name' => 'Container name',
                'memory' => 'Memory limit',
                'automaticStart' => 'Automatic start after system reboot',
                'automaticPortMapping' => 'Automatic port mapping',
                'portMapping' => 'Manual mapping',
                'toExternal' => 'to external',
                'volumeMapping' => 'Volume mapping',
                'volumeMappingSource' => 'Host',
                'volumeMappingDestination' => 'Container',
                'volumeMappingAddButton' => 'Add Mapping',
                'volumeMappingRemoveButton' => 'Remove',
                'environmentVariables' => 'Environment variables',
                'environmentVariablesName' => 'Variable',
                'environmentVariablesValue' => 'Value',
                'environmentVariablesAddButton' => 'Add Variable',
                'environmentVariablesRemoveButton' => 'Remove',
                'containerAlreadyExists' => 'The container with this name already exists.',
                'invalidContainerName' => 'Invalid container name: only Latin characters, numbers, underscore ("_"), period ("."), and dash ("-") are allowed, but the name must not start with a period or dash.',
            ],
            'container-recreate' => [
                'description' => 'Your container will be recreated from scratch using its previous settings. You can select a different image version for your new container.',
                'tag' => 'Image version',
                'currentTag' => 'Current',
                'reset' => 'Reset variables to default',
                'submit' => 'Recreate',
            ],
            'container-commit' => [
                'repository' => 'Image name',
                'tag' => 'Tag',
                'invalidRepositoryName' => 'The image name must start and end only with lower Latin characters and numbers. Underscore ("_"), period ("."), and dash ("-") are allowed as word separators. Multiple dashes like "---" are allowed.',
                'invalidTagName' => 'Invalid tag name: only Latin characters, numbers, underscore ("_"), period ("."), and dash ("-") are allowed, but the tag must not start with a period or dash.',
            ],
            'object-switcher' => [
                'dockercontainers' => [
                    'label' => 'Go to another container:',
                    'description' => 'Select another container.',
                ],
            ],
            'proxyRule' => [
                'path' => 'URL',
                'container' => 'Container',
                'port' => 'Port',
            ],
        ],

        'list' => [
            'configurations' => [
                'toolAdd' => 'Add Server',
                'toolAddDescription' => 'Attach a remote Docker node connection.',
                'toolActivate' => 'Set Active',
                'toolActivateDescription' => 'Use the selected node to provide the Docker service in Plesk.',
                'toolRemove' => 'Remove',
                'toolRemoveDescription' => 'Remove the selected node connection.',
                'removeConfirmation' => 'Confirm that you want to remove the selected nodes.',
                'columnActive' => 'Active',
                'columnServer' => 'Server',
                'columnDescription' => 'Description',
                'serverLocal' => 'Localhost',
                'ssl' => 'SSL',
            ],
            'proxyRules' => [
                'columnUrl' => 'URL',
                'columnContainer' => 'Target container',
                'columnPort' => 'Target port',
                'toolAdd' => 'Add Rule',
                'toolAddDescription' => 'Add a rule for nginx to proxy HTTP requests to an application running in a Docker container.',
                'toolRemove' => 'Remove',
                'toolRemoveDescription' => 'Remove the selected rules.',
                'removeConfirmation' => 'Do you want to remove the selected rules?',
                'port' => 'port',
            ],
            'domains' => [
                'description' => 'Requests to %%path%% are proxied to %%port%% port.',
                'removeButton' => 'Remove',
                'yes' => 'Yes',
                'no' => 'No',
                'confirmation' => 'Do you want to remove this Docker proxy rule?',
            ],
        ],

        'buttons' => [
            'yes' => 'Yes',
            'no' => 'No',
            'ok' => 'OK',
            'wait' => 'Please wait',
            'save' => 'OK',
            'apply' => 'Apply',
            'cancel' => 'Cancel',
            'close' => 'Close',
        ],

        'validate' => [
            'path' => [
                'start' => "Path '%value%' must be absolute.",
                'root' => "Path / is not allowed.",
            ],
            'webPath' => [
                'invalid' => "Path '%value%' must contain only alphanumeric characters.",
                'duplicate' => 'Mapping for these path and port already defined',
            ],
            'images' => [
                'imageExists' => 'An image with this name and tag already exists.'
            ],
            'env' => [
                'invalidName' => "The name of an environment variable can consist solely of uppercase letters, digits, and the underscore ('_'), and cannot begin with a digit.",
            ],
        ],

        'task' => [
            'image-download' => [
                'downloading' => 'Downloading the image from Docker Hub...',
                'progress' => '%%current%%MB of %%total%%MB downloaded...',
                'run' => 'Running %%name%%',
            ],
        ],
    ],

    'exceptions' => [
        'serviceIsUnavailable' => 'The Docker service is unavailable: %%error%%',
    ],

    'statuses' => [
        'success' => 'Success',
        'failed' => 'Failed',
    ],

    'literals' => [
        'byte' => 'B',
        'kilo' => 'K',
        'mega' => 'M',
        'giga' => 'G',
        'tera' => 'T',
    ],

    'navDockerButton' => 'Docker',
    'navDockerButtonDescription' => 'Manage Docker containers.',
    'dockerSettingsButtonDescription' => 'Configure Docker connection settings.',
    'proxyRulesButton' => 'Docker Proxy Rules',
    'proxyRulesButtonDescription' => 'Set up rules for nginx to proxy requests to applications running in Docker containers.',

    '__perm_denied' => 'Permission denied.',
    '__mb' => 'MB',
    'remoteDockerNotAllowed' => 'Remote Docker is not allowed by your license.',
    'remoteDockerLimitExceeded' => 'License limits for remote Docker configurations were exceeded.',
];
